module apb_top ( input logic clk, input logic ares,
                 apb_if.slave host );

    import apb_pkg::SLAVE_TEMPS;
    import apb_pkg::SLAVE_BD_MONTH;
    import apb_pkg::SLAVE_DAY_MASK;

    apb_if slave[apb_pkg::SLAVE_NUM]();

    apb_bridge bridge (.master(host), .slave);

    reg_temps    temps  (.apb(slave[SLAVE_TEMPS]),    .temps(),   .*);
    reg_bd_month bdmonth(.apb(slave[SLAVE_BD_MONTH]), .bdMonth(), .*);    
    reg_day_mask daymask(.apb(slave[SLAVE_DAY_MASK]), .dayMask(), .*);

endmodule
